//Umgang mit linearen Listen
//Aufg 4


#include <iostream.h>
enum { FALSE , TRUE } ;
typedef int ELEMTYP;

class IntListAsVector {
		// unsortierte Liste ganzer Zahlen unbeschrnkter Lnge
  public:
	 	// Konstruktor-Funktion initialisiert leere Liste;
	IntListAsVector ( );

	 	// Destruktor-Funktion gibt Speicher frei;
	~IntListAsVector ( );

	 	// prft ob 0<=pos<=aktuelle Lnge der Liste ist, trgt ggf. "elem" vor "pos" (d.h.
	 	// zwischen [pos-1] und [pos]) ein und liefert im Erfolgsfall TRUE, sonst FALSE
		// zurck
	int add (ELEMTYP elem, int pos);

	 	// prft ob 0<=pos<aktuelle Lnge der Liste ist, lscht ggf. "pos"-tes Element
	 	// und liefert im Erfolgsfall TRUE, sonst FALSE zurck
	int del (int pos);	

	 	// prft ob 0<=pos<aktuelle Lnge der Liste ist und liefert im Erfolgsfall Wert des
	 	// "pos"-ten Elements zurck; sonst wird Meldung ausgegeben
	ELEMTYP elem (int pos);

	 	// liefert "pos", falls Wert des "pos"-ten Elements == "elem" ist und zw. Position "0"
		// und "pos" kein Element den Wert "elem" besitzt; liefert -1, falls "elem" nicht in der
	 	// Liste enthalten ist
	int lookup (ELEMTYP elem);

	 	// liefert TRUE, falls Liste leer, ansonsten FALSE
	int empty ();

	 	// liefert die Lnge der Liste zurck
	int length ();

	 	// druckt Liste aus
	void display ();

		//sortiert die Liste
	void sort();

		//kehrt die Liste um
	void reverse();


  private:
		// Implementierung eines Vektors ganzer Zahlen
	ELEMTYP *data; 	// Vektor ganzer Zahlen
	int maxsize;  	// Grsse des Vektors
	int aktsize;  	// aktuelle Elementanzahl im Vektor
	int inc;  		// gefuellter Vektor wird um inc Elemente erweitert
};


//Methodendefinitionen

IntListAsVector::IntListAsVector ( ) {
		if (data = new ELEMTYP [ 5 ] ) {
				maxsize = 5; aktsize = 0; inc = 3;
			}
		else 
			cout << "storage allocation error in constructor\n";
	}


IntListAsVector::~IntListAsVector ( ) {
		delete data; maxsize=0; aktsize=0;
	}


int IntListAsVector::add (ELEMTYP elem, int pos) { 
		if (pos>aktsize || pos<0)
			return FALSE;
		if (aktsize==maxsize) { // Vektor vollstaendig gefuellt
			ELEMTYP *newdata, *olddata;
			if (newdata = new ELEMTYP [maxsize+inc]) { // Anlegen groesseren Speichers
				for (int i=0 ; i<aktsize ; i++) {
					newdata[i] = data[i]; // Kopieren des Vektorinhalts in neuen Bereich
				}
				maxsize+=inc;
				olddata = data;
				data = newdata;
				delete olddata;
			}
		}
		for (int i=aktsize;i>pos;i--)
			data[i]=data[i-1];
		data[pos]=elem;
		aktsize++;
		return TRUE;
	}


int IntListAsVector::del (int pos) {
		if (pos>aktsize || pos<0)
			return FALSE;
		for (int i=pos; i<aktsize; i++)
			data[i]=data[i+1];
		aktsize--;
		if (maxsize-aktsize==inc){	// Vektor mit mehr als inc freien Plaetzen
			ELEMTYP *newdata, *olddata;
			if (newdata = new ELEMTYP[maxsize-inc]){	// Anlegen kleineren Speichers
				for (i=0;i<aktsize;i++)
					newdata[i]=data[i];		// Kopieren des Vektorinhalts in neuen Bereich
				maxsize-=inc;
				olddata=data;
				data=newdata;
				delete olddata;
			}
		}
	
	
	return TRUE;
	}


ELEMTYP IntListAsVector::elem (int pos) {
		if (pos>aktsize || pos<0)
			return FALSE;
		else
			return data[pos];
	}


int IntListAsVector::lookup (ELEMTYP elem) {  
		for (int i=0; i<=aktsize; i++){
			if (data[i]==elem)
				return i;
		}
		return -1;
	}


int IntListAsVector::empty () {  
		if (aktsize==0)
			return TRUE;
		else
			return FALSE;
	}


int IntListAsVector::length () {  
		return aktsize;
	}


void IntListAsVector::display () { 
		for (int i=0;i<aktsize; i++)
			cout<<i<<". Element: "<<data[i] << endl;
		cout << "Ende der aktuellen Ausgabe!" <<" (display())" <<endl;
	}


void IntListAsVector::sort(){
	int i,j,k;
	ELEMTYP einElement;
	for (i=1; i<aktsize; i++){
		einElement = data[i];
		j = i-1;
		while (j>=0 && (einElement<=data[j]) == true) j--;
		for (k=i; k>=j+2; k--) data[k] = data[k-1];
		data[j+1] = einElement;
	}
}


void IntListAsVector::reverse(){
	int left, right = aktsize-1;
	ELEMTYP tmp;
	for (left=0; left<(aktsize/2); left++){
		tmp = data[left];
		data[left] = data[right];
		data[right] = tmp;
		right--;
	}
}

/////////////////////////////////////////////////////////////////////////////////////

void IntListAsVectorDrv();					//Treiberfunktion zum Testen der Methoden
void concat(IntListAsVector *, IntListAsVector *, IntListAsVector *);	//Fuegt 2 Listen zusammen

void main ()								//Mainfunktion
{
	IntListAsVectorDrv();

	char dummy;
	cout <<"Weiter mit 'w' ";
	cin >>dummy;

	IntListAsVector fp_liste1;
	IntListAsVector fp_liste2;
	IntListAsVector fp_liste3;

	fp_liste1.add(5,0);
	fp_liste1.add(6,1);
	fp_liste1.add(4,2);
	fp_liste1.add(3,3);

	fp_liste2.add(8,0);
	fp_liste2.add(2,1);
	fp_liste2.add(0,2);

	concat(&fp_liste1, &fp_liste2, &fp_liste3);
	cout <<"\nconcat()" <<endl;
	fp_liste1.display();
	fp_liste2.display();
	fp_liste3.display();

	return;
}


void concat(IntListAsVector *fp_liste1, IntListAsVector *fp_liste2, 
			IntListAsVector *fp_liste3){
	int i, j=0;
	for (i=0; i<(fp_liste1->length()+fp_liste2->length()); i++)
	{
		if(i < fp_liste1->length())
			fp_liste3->add(fp_liste1->elem(i),i);
		else
		{
			fp_liste3->add(fp_liste2->elem(j),i);
			j++;
		}
	}
	return;
}


void IntListAsVectorDrv(){				//Treiberdefinition
	int pos=2,		//Welche Stelle soll geprueft werden, ob sie im Vektor liegt?
		loesch=2,	//Welche Stelle soll geloescht werden?
		wert=4;		//Nach welchem Wert soll gesucht werden?

	IntListAsVector a;
	
	
	a.add(5,0);
	a.add(6,1);
	a.add(4,2);
	a.add(3,3);
	//a.add(7,4);

	a.display();

	a.del(loesch);		//Loeschfunktion
	cout <<"Element an Stelle " <<loesch <<" geloescht. (loesch())" <<endl;

	if (a.elem(pos)!=FALSE)		//elem
		cout <<"Laenge ist in Ordnung. Wert auf Position(" <<pos <<")= " 
		     <<a.elem(pos) <<" (elem())" <<endl;
	else
		cout <<"Liste hat nicht " <<pos <<" Positionen!" <<" (elem())" <<endl;
	a.display();
	
	cout <<"Aktuelle Laenge: " <<a.length() <<" (length())" <<endl;	//testen der Laenge

	if (a.empty()==FALSE)		//Liste leer?
		cout <<"Vektor ist nicht leer." <<" (empty())" <<endl;
	else
		cout <<"Vektor ist leer." <<" (empty())" <<endl;

	cout <<"Suche nach Wert '" <<wert <<"' liefert Rueckgabewert: " <<a.lookup(wert) 
		 <<" (lookup())" <<endl;

	a.sort();
	cout <<"Jetzt wurde sortiert! (sort())" <<endl;
	a.display();

	a.reverse();
	cout <<"Jetzt wurde umgekehrt! (reverse())" <<endl;
	a.display();

	return;
}