//Umgang mit verketteten Listen
//Aufg 5


#include <iostream.h>
enum { FALSE , TRUE } ;
typedef int ELEMTYP;

class IntListAsPointer {
        // unsortierte Liste ganzer Zahlen, implementiert als einfach verkettete Liste
  public:
                // initialisiert leere Liste;
        IntListAsPointer ();

                // Gibt Speicher fuer Listenelemente frei
        ~IntListAsPointer ();

                // prft ob 0<=pos<=aktuelle Lnge der Liste ist, trgt ggf. "elem" vor 
				// "pos"(d.h. zwischen [pos-1] und [pos]) ein und liefert im Erfolgsfall TRUE,
                // sonst FALSE zurck
        int add (ELEMTYP elem, int pos);

                // prft ob 0<=pos<aktuelle Lnge der Liste ist, lscht ggf. "pos"-tes 
                // Element und liefert im Erfolgsfall TRUE, sonst FALSE zurck
        int del (int pos);

                // prft ob 0<=pos<aktuelle Lnge der Liste ist und liefert im Erfolgsfall 
                // Wert des "pos"-ten Elements zurck. sonst wird Meldung ausgegeben
        ELEMTYP elem (int pos);

                // liefert "pos", falls Wert des "pos"-ten Elements == "elem" ist und 
                // zw. Position "0" und "pos" kein Element den Wert "elem" besitzt; liefert -1, 
                // falls "elem" nicht in der Liste enthalten ist
        int lookup (ELEMTYP elem);

                // liefert TRUE, falls Liste leer, ansonsten FALSE
        int empty ();

                // liefert die Lnge der Liste zurck
        int length ();

                // druckt Liste aus
        void display ();

				// sortiert die Liste
		void sort();

				// kehrt die Liste um
		void reverse();

  private:
                // Implementierung einer Liste ganzer Zahlen
        typedef struct node {
                ELEMTYP data;
                struct node *next;
        } NODE;

        NODE *head;		// Zeiger auf Listenanfang
        int size;       // aktuelle Lnge der Liste
};




IntListAsPointer::IntListAsPointer () { head = NULL; size = 0; }

IntListAsPointer::~IntListAsPointer () { 
                while (head) {
                        NODE *tmp = head; 
                        head = head->next;
                        delete tmp;
                }
                size = 0;
        }

int IntListAsPointer::add (ELEMTYP elem, int pos) { 
                if (pos>size || pos<0)
                        return FALSE;
                NODE *tmp = head;
                if (head) {
                        for (int i=0; i<pos-1; i++)
                                tmp = tmp->next;
                         // tmp zeigt jetzt auf "pos-1"-tes Element 
                }
                        
                NODE *tmp2 = new NODE;
                tmp2->data=elem;
                if (head && pos>0) { // nichtleere Liste, nicht an erster Position
                        tmp2->next=tmp->next;
                        tmp->next = tmp2;
                }
                else if (head && pos==0) { // nichtleere Liste, an erster Position
                        tmp2->next = head;
                        head = tmp2;
                }
                else {  // leere Liste
                        tmp2->next=NULL;
                        head = tmp2;
                }
                size++;
                return TRUE;
        }

int IntListAsPointer::del (int pos) {
			if (pos>size || pos<0)
				return FALSE;
			NODE *tmp = head;
                if (head) {
                        for (int i=0; i<pos-1; i++)
                                tmp = tmp->next;
											// tmp zeigt jetzt auf "pos-1"-tes Element 
				}
			
			if (head && pos>0) {			// nichtleere Liste, nicht an erster Position
				NODE *tmp2 = tmp;
				tmp2 = tmp->next;			// tmp2 zeigt jetzt auf "pos"-tes Element
				tmp->next = tmp2->next;		// tmp zeigt jetzt auf "pos+1"-tes Element
				delete tmp2;				// Speicherfreigabe
				size--;						// Anpassen der Groesse
			return TRUE;
			}

			else if (head && pos==0) {		// nur ein Listenelement
				NODE *tmp = head; 
				head = head->next;
				delete tmp;
				size--;						// Anpassen der Groesse
			return TRUE;
			}
			
			else
				return FALSE; // leere Liste
        }

ELEMTYP IntListAsPointer::elem (int pos) {
			if (pos>size-1 || pos<0)
				return FALSE;
			NODE *tmp = head;
                if (head) {
                        for (int i=0; i<pos; i++)
                                tmp = tmp->next;
										// tmp zeigt jetzt auf "pos"-tes Element 
				}
				return tmp->data;
        }

int IntListAsPointer::lookup (ELEMTYP elem) {  
			NODE *tmp = head;
                if (head) {
					for (int i=0; i<size; i++){
						if (tmp->data == elem)
							return i;
						tmp = tmp->next;
					}
				}
					return -1;
        }

int IntListAsPointer::empty () {  
			if (size == 0)
				return TRUE;
			else
				return FALSE;
        }

int IntListAsPointer::length () { 
			return size;
        }

void IntListAsPointer::display () {
			NODE *tmp = head;

			for(int i=0; i<size; i++){
				cout <<i <<". Element: "<<tmp->data <<endl;
				tmp = tmp->next;
			}
			cout << "Ende der aktuellen Ausgabe!" <<" (display())" <<endl;
        }

void IntListAsPointer::sort(){
	int i,j,k,einElem1;
	NODE *tmp1 = head;
	NODE *tmp2;
	NODE *tmp3;
	k = size;

	for (i=0; i<size; i++){
		tmp3 = tmp1;			//beginn jedesmal am anfang des feldes
		tmp2 = tmp1->next;		//ein element rechts von tmp1
		for (j=1; j<k; j++){
			if (tmp3->data <= tmp2->data){
				tmp2 = tmp2->next;			//ein element weiter nach rechts
				tmp3 = tmp3->next;			//ein element weiter nach rechts
			}
			else {
				einElem1 = tmp2->data;		//vertauschen
				tmp2->data = tmp3->data;	//vertauschen
				tmp3->data = einElem1;		//vertauschen

				tmp2 = tmp2->next;			//ein element weiter nach rechts
				tmp3 = tmp3->next;			//ein element weiter nach rechts
			}
		}
		k--;	//nach jeden durchlauf befindet sich die jeweils groesste ziffer ganz rechts
				//das zu ueberpruefende feld kann somit verkleinert werden. deshalb k--;
	}
}

void IntListAsPointer::reverse(){
	int left, right = size, einElem1;
	NODE *tmp1 = head;
	NODE *tmp2 = tmp1;

	for (left=0; left<size/2; left++)
	{
		for (int i=left; i<right-1; i++){
			tmp2 = tmp2->next;
		}
		einElem1 = tmp2->data;		//vertauschen
		tmp2->data = tmp1->data;	//vertauschen
		tmp1->data = einElem1;		//vertauschen
		right--;
		tmp1 = tmp1->next;			//rechtsschritt
		tmp2 = tmp1;
	}
}


/////////////////////////////////////////////////////////////////////////////////////

void IntListAsPointerDrv();					//Treiberfunktion zum Testen der Methoden
void concat(IntListAsPointer *, IntListAsPointer *, IntListAsPointer *);	
											//Fuegt 2 Listen zusammen

void main ()								//Mainfunktion
{
	IntListAsPointerDrv();
	char dummy;

	cout <<"Weiter mit 'w' ";
	cin >>dummy;
	cout <<endl;

	IntListAsPointer fp_liste1;
	IntListAsPointer fp_liste2;
	IntListAsPointer fp_liste3;

	fp_liste1.add(5,0);
	fp_liste1.add(6,1);
	fp_liste1.add(4,2);
	fp_liste1.add(3,3);

	fp_liste2.add(8,0);
	fp_liste2.add(2,1);
	fp_liste2.add(0,2);

	concat(&fp_liste1, &fp_liste2, &fp_liste3);
	cout <<"\nconcat()" <<endl;
	fp_liste1.display();
	fp_liste2.display();
	fp_liste3.display();
	return;
}


void concat(IntListAsPointer *fp_liste1, IntListAsPointer *fp_liste2, IntListAsPointer *fp_liste3)
{
	int i, j=0;
	for (i=0; i<(fp_liste1->length()+fp_liste2->length()); i++)
	{
		if(i < fp_liste1->length())
			fp_liste3->add(fp_liste1->elem(i),i);
		else
		{
			fp_liste3->add(fp_liste2->elem(j),i);
			j++;
		}
	}
	return;
}


void IntListAsPointerDrv(){
	int pos=1,		//Welche Stelle soll geprueft werden, ob sie im Vektor liegt?
		loesch=2,	//Welche Stelle soll geloescht werden?
		wert=6;		//Nach welchem Wert soll gesucht werden?

	IntListAsPointer a;

	char dummy;

	a.add(8,0);
	a.add(6,1);
	a.add(7,2);
	a.add(5,3);
	a.add(2,4);
	a.display();

	if (a.elem(pos)!=FALSE)		//elem
		cout <<"Laenge ist in Ordnung. Wert auf Position " <<pos <<" = " 
		     <<a.elem(pos) <<" (elem())" <<endl;
	else
		cout <<"Liste hat nicht " <<pos <<" Positionen!" <<" (elem())" <<endl;

	a.del(loesch);
	cout <<"Element an " <<loesch <<". Stelle geloescht. (loesch())" <<endl;
	a.display();

	cout <<"Suche nach Wert '" <<wert <<"' liefert Rueckgabewert: " <<a.lookup(wert) 
		 <<" (lookup())" <<endl;

	if (a.empty()==FALSE)		//Liste leer?
		cout <<"Vektor ist nicht leer." <<" (empty())" <<endl;
	else
		cout <<"Vektor ist leer." <<" (empty())" <<endl;

	cout <<"Aktuelle Laenge: " <<a.length() <<" (length())" <<endl;	//testen der Laenge

	cout <<"Weiter mit 'w' ";
	cin >>dummy;
	cout <<endl;

	a.sort();
	cout <<"Liste wurde sortiert!" <<" (sort())" <<endl;
	a.display();

	a.reverse();
	cout <<"Jetzt wurde umgekehrt! (reverse())" <<endl;
	a.display();

	return;
}